Subject: Re: `git stash pop` UX Problem

From: Junio C Hamano <[email-masked]>
Date: Tue, 25 Feb 2014 14:23:04 -0800

Stephen Leake <[email-masked]> writes:

>> Dropping the stash on a "git add" operation would be really, really
>> weird...
>
> Why? That is when the merge conflicts are resolved, which is what
> logically indicates that the stash is no longer needed,...

Not necessarily.  Imagine a case where you used stash to quickly
save away a tangled mess that was not ready for a logically single
commit and now you are in the process of creating the first commit
by applying it piece-by-piece to create multiple resulting ones.
After you commit the result, you would still want to keep the parts
of that stashed change you did not include in the first commit so
that you can go back, no?

You may run "git add", but that does not say anything about what you
are going to use the rest of the stash for.  Not even "git commit"
may be a good enough sign.